import React from 'react';
import PropTypes from 'prop-types';
import { icons } from './utils/iconConstants';

var Icon = function Icon(props) {
  return React.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: props.size,
    height: props.size,
    viewBox: "-6 -6 36 36"
  }, props.children, icons[props.icon].map(function (path) {
    return React.createElement("path", {
      key: path,
      d: path
    });
  }));
};

Icon.propTypes = {
  icon: PropTypes.string.isRequired,
  size: PropTypes.number.isRequired
};
export default Icon;