function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React from "react";
import ReactDOM from "react-dom";
import PropTypes from "prop-types";
import ImageModifiers from "./ImageModifiers";
import Icon from "./Icon";
import { containsClass } from "./utils/classNames";
import "./Image.css";
var ZOOM_STEP = 1.1;
var _ref = [Math.pow(ZOOM_STEP, 30), Math.pow(1 / ZOOM_STEP, 10)],
    MAX_ZOOM_SIZE = _ref[0],
    MIN_ZOOM_SIZE = _ref[1];

var extname = function extname() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
  var temp = url.split('/');
  var filename = temp[temp.length - 1];
  var filenameWithoutSuffix = filename.split(/#|\?/)[0];
  return (/\.[^./\\]*$/.exec(filenameWithoutSuffix) || [''])[0];
}; // const regpPdfHandle = text => /^https?.*(pdf|PDF)$/.test(text);


var isImageUrl = function isImageUrl(url) {
  var extension = extname(url);

  if (/^data:image\//.test(url) || /(webp|svg|png|gif|jpg|jpeg|jfif|bmp|dpg|ico)$/i.test(extension)) {
    return true;
  }

  if (/^data:/.test(url)) {
    // other file types of base64
    return false;
  }

  if (extension) {
    // other file types which have extension
    return false;
  }

  return false;
};

var regpPdfHandle = function regpPdfHandle(url) {
  var extension = extname(url);

  if (/^data:application\/pdf/.test(url) || /(pdf|PDF)$/i.test(extension)) {
    return true;
  }

  if (/^data:/.test(url)) {
    // other file types of base64
    return false;
  }

  if (extension) {
    // other file types which have extension
    return false;
  }

  return true;
};

var ImageContent =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ImageContent, _React$Component);

  function ImageContent(props) {
    var _this2;

    _classCallCheck(this, ImageContent);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(ImageContent).call(this, props));

    _this2.renderPDF = function () {
      var src = _this2.props.src;
      return React.createElement("div", {
        style: {
          height: "100%"
        },
        dangerouslySetInnerHTML: {
          __html: "<embed src=".concat(src, " type=\"application/pdf\" width=\"100%\" height=\"100%\">")
        }
      });
    };

    _this2.resetImageInitialState = _this2.resetImageInitialState.bind(_assertThisInitialized(_this2));
    _this2.handleWindowResize = _this2.handleWindowResize.bind(_assertThisInitialized(_this2));
    _this2.handleRotate = _this2.handleRotate.bind(_assertThisInitialized(_this2));
    _this2.handleZoom = _this2.handleZoom.bind(_assertThisInitialized(_this2));
    _this2.setZoomLimits = _this2.setZoomLimits.bind(_assertThisInitialized(_this2));
    _this2.handleWheel = _this2.handleWheel.bind(_assertThisInitialized(_this2));
    _this2.handleMove = _this2.handleMove.bind(_assertThisInitialized(_this2));
    _this2.handleMoveEnd = _this2.handleMoveEnd.bind(_assertThisInitialized(_this2));
    _this2.handleMoveStart = _this2.handleMoveStart.bind(_assertThisInitialized(_this2));
    _this2.isInsideImage = _this2.isInsideImage.bind(_assertThisInitialized(_this2));
    _this2.state = {
      loader: true,
      ratio: 1,
      positionX: 0,
      positionY: 0,
      rotate: 0,
      width: 0,
      height: 0,
      boxWidth: 0,
      boxHeight: 0
    };
    return _this2;
  }

  _createClass(ImageContent, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.resetImageInitialState(this.props);
      this.startPoints = null;
      window.addEventListener("resize", this.handleWindowResize);
      document.addEventListener("mousedown", this.handleMoveStart);
      document.addEventListener("mouseup", this.handleMoveEnd);
      document.addEventListener("touchstart", this.handleMoveStart);
      document.addEventListener("touchend", this.handleMoveEnd);
      window.setTimeout(this.props.toggleControls, 500);

      if (this.props.showImageModifiers) {
        document.addEventListener("mousemove", this.handleMove);
        document.addEventListener("touchmove", this.handleMove);
        document.addEventListener("wheel", this.handleWheel);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener("resize", this.handleWindowResize);
      document.removeEventListener("mousedown", this.handleMoveStart);
      document.removeEventListener("mousemove", this.handleMove);
      document.removeEventListener("mouseup", this.handleMoveEnd);
      document.removeEventListener("touchstart", this.handleMoveStart);
      document.removeEventListener("touchmove", this.handleMove);
      document.removeEventListener("touchend", this.handleMoveEnd);
      document.removeEventListener("wheel", this.handleWheel);
    }
  }, {
    key: "resetImageInitialState",
    value: function resetImageInitialState(props) {
      var img = new Image();

      var _this = this;

      img.onload = function () {
        var _ref2 = [this.width, this.height],
            width = _ref2[0],
            height = _ref2[1];
        var box = ReactDOM.findDOMNode(_this.refs.container);
        var _ref3 = [box.offsetWidth, box.offsetHeight],
            boxWidth = _ref3[0],
            boxHeight = _ref3[1];
        var ratio = Math.min(boxWidth / width, boxHeight / height);
        if (isNaN(ratio)) ratio = 1;

        _this.setState({
          loader: false,
          ratio: ratio,
          rotate: 0,
          positionX: (boxWidth - width * ratio) / 2,
          positionY: (boxHeight - height * ratio) / 2,
          width: this.width,
          height: this.height,
          boxWidth: boxWidth,
          boxHeight: boxHeight,
          moving: false
        });
      };

      img.src = props.src;
    }
  }, {
    key: "handleWindowResize",
    value: function handleWindowResize() {
      this.resetImageInitialState(this.props);
    }
  }, {
    key: "handleRotate",
    value: function handleRotate(angle) {
      this.setState({
        rotate: (360 + this.state.rotate + angle) % 360
      });
    }
  }, {
    key: "handleZoom",
    value: function handleZoom(direction, scale) {
      if (!scale) scale = 1;
      var percent = direction > 0 ? Math.pow(ZOOM_STEP, scale) : Math.pow(1 / ZOOM_STEP, scale);
      var ratio = this.setZoomLimits(this.state.ratio * percent);
      var state = this.state;
      var delta = 0.05;
      var newPositionX, newPositionY;

      if (Math.min(state.boxWidth / state.width, state.boxHeight / state.height) >= ratio - delta) {
        newPositionX = (state.boxWidth - state.width * ratio) / 2;
        newPositionY = (state.boxHeight - state.height * ratio) / 2;
      } else {
        // Center image from container's center
        var offsetX = state.boxWidth / 2;
        var offsetY = state.boxHeight / 2;
        var bgCursorX = offsetX - state.positionX;
        var bgCursorY = offsetY - state.positionY;
        var bgRatioX = bgCursorX / (state.width * state.ratio);
        var bgRatioY = bgCursorY / (state.height * state.ratio);
        newPositionX = offsetX - state.width * ratio * bgRatioX;
        newPositionY = offsetY - state.height * ratio * bgRatioY;
      }

      this.setState({
        ratio: ratio,
        positionX: newPositionX,
        positionY: newPositionY
      });
    }
  }, {
    key: "setZoomLimits",
    value: function setZoomLimits(size) {
      var state = this.state;
      var originalRatio = Math.min(state.boxWidth / state.width, state.boxHeight / state.height);
      if (size / originalRatio > MAX_ZOOM_SIZE) return MAX_ZOOM_SIZE * originalRatio;else if (size / originalRatio < MIN_ZOOM_SIZE) return MIN_ZOOM_SIZE * originalRatio;else return size;
    }
  }, {
    key: "handleWheel",
    value: function handleWheel(ev) {
      if (this.isInsideImage(ev)) this.handleZoom(ev.deltaY);
    }
  }, {
    key: "handleMove",
    value: function handleMove(ev) {
      ev = this.getEv(ev);
      var state = this.state;
      if (!state.moving) return;
      var posX, posY;

      switch (state.rotate) {
        case 90:
          posY = this.startPoints[0] - ev.pageX;
          posX = ev.pageY - this.startPoints[1];
          break;

        case 180:
          posX = this.startPoints[0] - ev.pageX;
          posY = this.startPoints[1] - ev.pageY;
          break;

        case 270:
          posY = ev.pageX - this.startPoints[0];
          posX = this.startPoints[1] - ev.pageY;
          break;

        default:
          posX = ev.pageX - this.startPoints[0];
          posY = ev.pageY - this.startPoints[1];
      }

      this.startPoints = [ev.pageX, ev.pageY];
      if (state.positionX + posX >= 0 || state.positionX + posX <= state.boxWidth - state.width * state.ratio) posX = 0;
      if (state.positionY + posY >= 0 || state.positionY + posY <= state.boxHeight - state.height * state.ratio) posY = 0;
      this.setState({
        positionX: state.positionX + posX,
        positionY: state.positionY + posY
      });
    }
  }, {
    key: "handleMoveEnd",
    value: function handleMoveEnd(ev) {
      this.setState({
        moving: false
      });
    }
  }, {
    key: "handleMoveStart",
    value: function handleMoveStart(ev) {
      ev = this.getEv(ev);
      if (!this.isInsideImage(ev) || ev.which !== 1) return;
      this.startPoints = [ev.pageX, ev.pageY];
      this.setState({
        moving: true
      });

      var _this = this; // check if touch was a tap


      window.setTimeout(function () {
        if (!_this.state.moving && _this.startPoints && _this.startPoints[0] === ev.pageX && _this.startPoints[1] === ev.pageY && containsClass(ev.target, ["lightbox-backdrop", "lightbox-image"])) {
          _this.props.toggleControls();
        }
      }, 200);
    }
  }, {
    key: "isInsideImage",
    value: function isInsideImage(ev) {
      var rect = ReactDOM.findDOMNode(this.refs.container).getBoundingClientRect();
      if (ev.pageY < rect.top || ev.pageY > rect.bottom || ev.pageX < rect.left || ev.pageX > rect.right) return false;
      return true;
    }
  }, {
    key: "getEv",
    value: function getEv(ev) {
      if (ev.type === "touchstart" || ev.type === "touchmove" || ev.type === "touchend") return {
        pageX: ev.touches[0].pageX,
        pageY: ev.touches[0].pageY,
        which: 1,
        target: ev.target
      };
      return ev;
    }
  }, {
    key: "render",
    value: function render() {
      var _ref4 = [this.props, this.state],
          props = _ref4[0],
          state = _ref4[1];
      var background = "url(".concat(props.src, ")");
      var modifiers, loader;

      if (props.showImageModifiers) {
        modifiers = React.createElement(ImageModifiers, {
          handleRotate: this.handleRotate,
          handleZoom: this.handleZoom,
          currentImage: props.src
        });
      }

      if (state.loader) {
        background = "none";
        loader = React.createElement("div", {
          className: "lightbox-loader"
        }, React.createElement(Icon, {
          icon: "spinner",
          size: 58
        }));
      } // const customContent = props.customContent ? props.customContent : null;


      var transform = "rotate(".concat(state.rotate, "deg)");
      var styles = {
        height: "100%",
        backgroundImage: isImageUrl(props.src) ? background : "none",
        backgroundRepeat: "no-repeat",
        backgroundSize: "".concat(state.width * state.ratio, "px ").concat(state.height * state.ratio, "px"),
        backgroundPosition: "".concat(state.positionX, "px ").concat(state.positionY, "px"),
        MsTransform: transform,
        WebkitTransform: transform,
        transform: transform
      };
      return React.createElement("div", {
        className: "lightbox-content-center"
      }, modifiers, React.createElement("div", {
        className: "lightbox-image-container",
        ref: "container"
      }, React.createElement("div", {
        className: "lightbox-image" + (state.moving ? " moving" : ""),
        style: styles
      }, regpPdfHandle(props.src) ? this.renderPDF() : "文件格式无法展示")));
    }
  }]);

  return ImageContent;
}(React.Component);

export { ImageContent as default };
Image.propTypes = {
  src: PropTypes.string.isRequired,
  showImageModifiers: PropTypes.bool.isRequired
};