"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactTransitionGroup = require("react-transition-group");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Image = _interopRequireDefault(require("./Image"));

var _Button = _interopRequireDefault(require("./Button"));

var _classNames = require("./utils/classNames");

require("./Container.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var transitionTime = 300;
var transitionDelta = 50;

var Container =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Container, _React$Component);

  function Container(props) {
    var _this;

    _classCallCheck(this, Container);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Container).call(this, props));
    _this.handleLeftClick = _this.handleLeftClick.bind(_assertThisInitialized(_this));
    _this.handleRightClick = _this.handleRightClick.bind(_assertThisInitialized(_this));
    _this.canMoveToLeft = _this.canMoveToLeft.bind(_assertThisInitialized(_this));
    _this.canMoveToRight = _this.canMoveToRight.bind(_assertThisInitialized(_this));
    _this.toggleControls = _this.toggleControls.bind(_assertThisInitialized(_this));
    _this.handleKeyboard = _this.handleKeyboard.bind(_assertThisInitialized(_this));
    _this.getDescriptions = _this.getDescriptions.bind(_assertThisInitialized(_this));
    _this.state = {
      selectedImageIndex: props.selectedImage,
      direction: "none",
      imagesDescriptions: {}
    };
    _this.windowPageYOffset = 0;
    return _this;
  }

  _createClass(Container, [{
    key: "getDescriptions",
    value: function getDescriptions() {
      var _this2 = this;

      var images = this.state.imagesDescriptions;
      this.props.images.forEach(function (image, index) {
        if (!image.description) return;

        if (image.description.then) {
          //if promise
          image.description.then(function (data) {
            images[index] = data;

            _this2.setState({
              imagesDescriptions: images
            });
          });
          return;
        }

        images[index] = image.description;

        _this2.setState({
          imagesDescriptions: images
        });
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      this.getDescriptions();
      document.addEventListener("keydown", this.handleKeyboard);
      this.windowPageYOffset = window.pageYOffset;
      (0, _classNames.addClass)(document.documentElement, "lightbox-open");
      document.body.scroll = "no"; // ie only
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener("keydown", this.handleKeyboard);
      (0, _classNames.removeClass)(document.documentElement, "lightbox-open");
      document.documentElement.scrollTop = this.windowPageYOffset;
      document.body.scroll = "yes"; // ie only
    }
  }, {
    key: "handleKeyboard",
    value: function handleKeyboard(ev) {
      var key = ev.keyCode ? ev.keyCode : ev.which;

      if (this.timeLastTransition && new Date() - this.timeLastTransition < transitionTime + transitionDelta) {
        return;
      }

      this.timeLastTransition = new Date();

      switch (key) {
        case 37:
          return this.handleLeftClick();

        case 39:
          return this.handleRightClick();

        case 27:
          return this.props.toggleLightbox();

        default:
          break;
      }
    }
  }, {
    key: "handleLeftClick",
    value: function handleLeftClick() {
      if (this.canMoveToLeft()) {
        this.setState({
          selectedImageIndex: this.state.selectedImageIndex - 1,
          direction: "left"
        });
      }
    }
  }, {
    key: "handleRightClick",
    value: function handleRightClick() {
      if (this.canMoveToRight()) {
        this.setState({
          selectedImageIndex: this.state.selectedImageIndex + 1,
          direction: "right"
        });
      }
    }
  }, {
    key: "canMoveToLeft",
    value: function canMoveToLeft() {
      return this.state.selectedImageIndex > 0;
    }
  }, {
    key: "canMoveToRight",
    value: function canMoveToRight() {
      return this.state.selectedImageIndex < this.props.images.length - 1;
    }
  }, {
    key: "toggleControls",
    value: function toggleControls() {
      (0, _classNames.classToggle)(this.refs.container, "hide-controls");
    }
  }, {
    key: "render",
    value: function render() {
      var _ref = [this.props, this.state],
          props = _ref[0],
          state = _ref[1];
      var image = props.images[state.selectedImageIndex];
      var leftButton, rightButton;
      var descriptionText = state.imagesDescriptions[state.selectedImageIndex];
      var description = props.renderDescriptionFunc.call(this, descriptionText);
      var transitionName = "lightbox-transition-image";
      var cls = props.modalClassName ? "lightbox-backdrop ".concat(props.modalClassName, " ") : "lightbox-backdrop";
      if (this.canMoveToLeft()) leftButton = _react.default.createElement("div", {
        className: "lightbox-btn-left"
      }, _react.default.createElement(_Button.default, {
        icon: "left-arrow",
        onClick: this.handleLeftClick,
        size: 56,
        hasRipple: true
      }));
      if (this.canMoveToRight()) rightButton = _react.default.createElement("div", {
        className: "lightbox-btn-right"
      }, _react.default.createElement(_Button.default, {
        icon: "right-arrow",
        onClick: this.handleRightClick,
        size: 56,
        hasRipple: true
      }));
      return _react.default.createElement("div", {
        className: cls,
        ref: "container",
        style: props.modalStyle ? props.modalStyle : undefined
      }, _react.default.createElement("div", {
        className: "lightbox-btn-close"
      }, _react.default.createElement(_Button.default, {
        icon: "back-arrow",
        onClick: props.toggleLightbox,
        size: 34,
        hasRipple: true
      })), _react.default.createElement("div", {
        className: "lightbox-title-content"
      }, _react.default.createElement("div", {
        className: "lightbox-title"
      }, image.title), _react.default.createElement("div", {
        className: "lightbox-description"
      }, description)), _react.default.createElement(_reactTransitionGroup.CSSTransitionGroup, {
        transitionAppear: true,
        transitionAppearTimeout: transitionTime,
        transitionEnterTimeout: transitionTime,
        transitionLeaveTimeout: transitionTime,
        transitionName: {
          enter: "".concat(transitionName, "-enter-").concat(state.direction),
          enterActive: "".concat(transitionName, "-enter-").concat(state.direction, "-active"),
          leave: "".concat(transitionName, "-leave-").concat(state.direction),
          leaveActive: "".concat(transitionName, "-leave-").concat(state.direction, "-active"),
          appear: "".concat(transitionName, "-appear"),
          appearActive: "".concat(transitionName, "-appear-active")
        }
      }, _react.default.createElement(_Image.default, {
        key: image.src,
        src: image.src,
        customContent: image.customContent,
        showImageModifiers: props.showImageModifiers,
        toggleControls: this.toggleControls
      })), leftButton, rightButton);
    }
  }]);

  return Container;
}(_react.default.Component);

exports.default = Container;
Container.defaultProps = {
  selectedImage: 0,
  renderDescriptionFunc: function renderDescriptionFunc(descriptionText) {
    return _react.default.createElement("div", null, String(descriptionText));
  }
};
Container.propTypes = {
  selectedImage: _propTypes.default.number,
  images: _propTypes.default.array.isRequired,
  toggleLightbox: _propTypes.default.func.isRequired,
  showImageModifiers: _propTypes.default.bool,
  renderDescriptionFunc: _propTypes.default.func
};