"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _iconConstants = require("./utils/iconConstants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Icon = function Icon(props) {
  return _react.default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: props.size,
    height: props.size,
    viewBox: "-6 -6 36 36"
  }, props.children, _iconConstants.icons[props.icon].map(function (path) {
    return _react.default.createElement("path", {
      key: path,
      d: path
    });
  }));
};

Icon.propTypes = {
  icon: _propTypes.default.string.isRequired,
  size: _propTypes.default.number.isRequired
};
var _default = Icon;
exports.default = _default;