"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Container = _interopRequireDefault(require("./Container"));

var _BodyPortal = _interopRequireDefault(require("./BodyPortal"));

require("./Lightbox.css");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var isPDFHandle = function isPDFHandle(text) {
  return /^https?.*(pdf|PDF)$/.test(text);
};

var Lightbox =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Lightbox, _React$Component);

  function Lightbox(props) {
    var _this;

    _classCallCheck(this, Lightbox);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Lightbox).call(this, props));
    _this.toggleLightbox = _this.toggleLightbox.bind(_assertThisInitialized(_this));
    _this.state = {
      showLightbox: false,
      selectedImage: 0
    };
    return _this;
  }

  _createClass(Lightbox, [{
    key: "toggleLightbox",
    value: function toggleLightbox(idx) {
      this.setState({
        showLightbox: !this.state.showLightbox,
        selectedImage: idx
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var props = this.props;
      var cls = props.className ? "lightbox-container ".concat(props.className) : "lightbox-container";
      var images = props.images.map(function (image, idx) {
        return props.renderImageFunc.call(_this2, idx, image, _this2.toggleLightbox, props.thumbnailWidth, props.thumbnailHeight);
      });
      var container;
      if (this.state.showLightbox) container = _react.default.createElement(_BodyPortal.default, null, _react.default.createElement(_Container.default, _extends({}, this.props, {
        toggleLightbox: this.toggleLightbox,
        selectedImage: this.state.selectedImage
      })));
      return _react.default.createElement("div", {
        className: cls,
        style: props.style ? props.style : undefined
      }, images, container);
    }
  }]);

  return Lightbox;
}(_react.default.Component);

exports.default = Lightbox;
Lightbox.defaultProps = {
  showImageModifiers: true,
  thumbnailWidth: "80px",
  thumbnailHeight: "80px",
  renderImageFunc: function renderImageFunc(idx, image, toggleLightbox, width, height) {
    var isPdf = isPDFHandle(image.src);

    if (isPdf) {
      return _react.default.createElement("div", {
        key: idx,
        className: "lightbox-img-thumbnail",
        style: {
          width: width,
          height: height,
          display: "inline-block",
          overflow: "hidden",
          verticalAlign: "middle"
        },
        alt: image.title,
        onClick: toggleLightbox.bind(null, idx)
      }, _react.default.createElement("svg", {
        t: "1596591844492",
        className: "icon",
        viewBox: "0 0 1024 1024",
        version: "1.1",
        xmlns: "http://www.w3.org/2000/svg",
        "p-id": "1519"
      }, _react.default.createElement("path", {
        d: "M901.850593 926.476283a48.761858 48.761858 0 0 1-48.761859 48.761859H170.422718a48.761858 48.761858 0 0 1-48.761858-48.761859V48.762834a48.761858 48.761858 0 0 1 48.761858-48.761859h418.864363a48.761858 48.761858 0 0 1 34.620919 14.140939l263.801654 263.801654a48.761858 48.761858 0 0 1 14.140939 34.620919V926.476283z",
        fill: "#EBECF0",
        "p-id": "1520"
      }), _react.default.createElement("path", {
        d: "M901.850593 926.476283v48.761859a48.761858 48.761858 0 0 1-48.761859 48.761858H170.422718a48.761858 48.761858 0 0 1-48.761858-48.761858v-48.761859a48.761858 48.761858 0 0 0 48.761858 48.761859h682.666016a48.761858 48.761858 0 0 0 48.761859-48.761859z",
        fill: "#C1C7D0",
        "p-id": "1521"
      }), _react.default.createElement("path", {
        d: "M24.137143 536.381417h975.237166v243.809291a48.761858 48.761858 0 0 1-48.761858 48.761859H72.899001a48.761858 48.761858 0 0 1-48.761858-48.761859v-243.809291z",
        fill: "#FF5630",
        "p-id": "1522"
      }), _react.default.createElement("path", {
        d: "M121.66086 536.381417V438.8577l-97.523717 97.523717h97.523717zM901.850593 536.381417l0.975237-97.523717 97.036098 97.523717H901.850593z",
        fill: "#DE350B",
        "p-id": "1523"
      }), _react.default.createElement("path", {
        d: "M267.946434 585.143275h84.845634a57.051374 57.051374 0 0 1 41.935198 15.603795 55.1009 55.1009 0 0 1 16.091413 40.959961 55.588518 55.588518 0 0 1-16.091413 40.959961 59.001849 59.001849 0 0 1-43.398054 16.091413h-48.761858v76.556118H267.946434z m32.670446 81.919922h43.885672a42.422817 42.422817 0 0 0 25.843785-6.339041 23.893311 23.893311 0 0 0 7.801897-19.992362q0-24.868548-32.670445-24.868548h-44.860909zM434.71199 588.068987H511.755726a73.142787 73.142787 0 0 1 58.51423 25.356166 100.937047 100.937047 0 0 1 21.942836 68.266602 110.689418 110.689418 0 0 1-20.967599 69.729457A71.679932 71.679932 0 0 1 511.755726 780.190708H434.71199z m32.670445 158.963658H511.755726a43.398054 43.398054 0 0 0 36.083775-17.066651A75.093262 75.093262 0 0 0 560.517584 682.666992a70.704695 70.704695 0 0 0-13.65332-48.761859 48.761858 48.761858 0 0 0-37.546631-16.579031h-41.935198zM755.565018 618.788957h-100.937047v45.348529H755.565018v31.207589h-100.937047v81.919922h-32.670445v-190.171248H755.565018z",
        fill: "#FFFFFF",
        "p-id": "1524"
      }), _react.default.createElement("path", {
        d: "M901.850593 312.564487v6.82666h-263.801654a48.761858 48.761858 0 0 1-48.761858-48.761858V0.000975a48.761858 48.761858 0 0 1 34.620919 14.140939l264.289272 263.801654a48.761858 48.761858 0 0 1 13.653321 34.620919z",
        fill: "#C1C7D0",
        "p-id": "1525"
      })));
    }

    return _react.default.createElement("img", {
      key: idx,
      src: !!image.thumbnail ? image.thumbnail : image.src,
      className: "lightbox-img-thumbnail",
      style: {
        width: width,
        height: height
      },
      alt: image.title,
      onClick: toggleLightbox.bind(null, idx)
    });
  }
};
Lightbox.propTypes = {
  images: _propTypes.default.arrayOf(_propTypes.default.shape({
    src: _propTypes.default.string.isRequired,
    title: _propTypes.default.string,
    description: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
    thumbnail: _propTypes.default.string
  })).isRequired,
  showImageModifiers: _propTypes.default.bool,
  thumbnailWidth: _propTypes.default.string,
  thumbnailHeight: _propTypes.default.string,
  renderImageFunc: _propTypes.default.func,
  renderDescriptionFunc: _propTypes.default.func,
  className: _propTypes.default.string,
  style: _propTypes.default.object,
  modalStyle: _propTypes.default.object,
  modalClassName: _propTypes.default.string
};