"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.classGetNames = classGetNames;
exports.containsClass = containsClass;
exports.addClass = addClass;
exports.removeClass = removeClass;
exports.classToggle = classToggle;

function classGetNames(element) {
  if (typeof element.className !== 'string') return [];
  return element.className.split(/\s+/);
}

function containsClass(element, classNames) {
  classNames = [].concat(classNames);
  var classList = classGetNames(element);

  for (var i in classNames) {
    if (classList.indexOf(classNames[i]) > -1) {
      return true;
    }
  }

  return false;
}

function addClass(element, className) {
  if (!containsClass(element, className)) {
    element.className = [element.className, className].join(' ');
  }
}

function removeClass(element, className) {
  var classList = classGetNames(element);
  element.className = classList.filter(function (name) {
    return name !== className;
  }).join(' ');
}

function classToggle(element, className) {
  if (containsClass(element, className)) {
    removeClass(element, className);
  } else {
    addClass(element, className);
  }
}